/**
 * 
 */
package sim.math.field;

import sim.math.SVector3d;

/**
 * L'interface <b>SVectorField</b> reprsente un champ vectoriel o plusieurs opration mathmatique est supporte.
 * 
 * @author Simon Vezina
 * @since 2022-01-24
 * @version 2022-01-24
 */
public interface SVectorField {

  /**
   * Mthode pour obtenir une composante vectorielle appartenant  la coordonne r du champ vectoriel.
   * 
   * @param r La position o sera valu le champ vectoriel.
   * @return Une composante du champ vectoriel
   * @throws SUndefinedFieldException Si le champ n'est pas dfini  la coordonne r.
   */
  public SVector3d get(SVector3d r) throws SUndefinedFieldException;
  
  /**
   * Mthode pour raliser l'addition d'un champ vectoriel avec le champ vectoriel ralisant l'appel de cette mthode.
   * Un nouveau champ vectoriel sera retourn aprs la ralisation de cette addition.
   * 
   * @param f Le champ vectoriel  additionner.
   * @return L'addition d'un champ vectoriel.
   */
  public default SVectorField add(SVectorField f)
  {
    // Par dfaut, il faut transformer le champ vectoriel courant en champ vectoriel par liste ave son contenu.
    SListVectorField field = new SListVectorField(this);
    
    // Retourner le champ vectoriel par liste avec l'ajout de f.
    return field.add(f);
  }
  
}
