/**
 * 
 */
package sim.physics.field;

import sim.math.SVector3d;
import sim.math.field.SVectorField;
import sim.physics.SElectrostatics;

/**
 * La classe <b>SSphereUniformlyCharged</b> reprsente une sphre uniformment charge en surface.
 * 
 * @author Simon Vezina
 * @since 2022-01-25
 * @version 2022-02-02
 */
public class SSphereUniformlyCharged implements SVectorField {

  /**
   * ...
   */
  private final SVector3d position;
  
  /**
   * ...
   */
  private final double ray;
  
  /**
   * ...
   */
  private final double charge;
  
  /**
   * Mthode pour construire une sphre uniformment charge  sa surface.
   * Cette sphre  possdera toujours la mme densit surfacique de charge mme s'il y a d'autres champs
   * dans le voisinage.
   * 
   * @param position La position centrale de la sphre.
   * @param ray Le rayon de la sphre.
   * @param charge La charge lectrique de la sphre. 
   */
  public SSphereUniformlyCharged(SVector3d position, double ray, double charge)
  {
    this.position = position;
    this.ray = ray;
    this.charge = charge;
  }
  
  @Override
  public SVector3d get(SVector3d r) 
  {
    return SElectrostatics.sphereElectricField(this.position, this.ray, this.charge, r);
  }

}
