/**
 * 
 */
package sim.util;

import static org.junit.Assert.*;

import java.io.IOException;

import org.junit.Test;

/**
 * JUnit test permettant de valider les fonctionnalits de la classe <b>SLog</b>.
 * 
 * @author Simon Vzina
 * @since 2016-01-14
 * @version 2016-04-20
 */
public class SLogTest {

  /**
   * Test #1 permettant de valider les fonctionnalits des mthodes suivante :
   * <ul>setLogFileName(String file_name)</ul>
   * <ul>logWriteLine(String str)</ul>
   * <ul>closeLogFile()</ul>
   */
  @Test
  public void test1_setLogFileName_logWriteLine_closeLogFile()
  {
    String file_name = "log_test.txt";
    String directory = "test";
    
    try{
      
      // Choisir le rpertoire "test" comme lieu o le fichier Log sera enregistr.
      SLog.setLogDirectory(directory);
      
      // Nom du fichier log.
      SLog.setLogFileName(file_name);
      
    }catch(Exception e){
      fail("FAIL - " + e.getMessage());
    }
    
    SLog.setConsoleLog(false);
    
    SLog.logWriteLine("Ceci est un test!");
    SLog.logWriteLine("Ceci est encore un test!");
      
    try{
      SLog.closeLogFile();
    }catch(IOException e){
      fail("FAIL - " + e.getMessage());
    }
    
    // Vrifier si le fichier est localis.
    
    // Prsentement, le fichier semble s'crire aprs l'excution du code ce qui met ce test toujours en chec.
    /*
    SBrowser browser = new SBrowser();
    
    try {
      
      browser.goTo("test");
      browser.findFile("logTest.txt");
      
    } catch (FileNotFoundException | SManyFilesFoundException e) {
      fail("Ce test est en chec, car le fichier '" + file_name + " n'a pas t trouv dans le rpertoire '" + directory +"'.");
    }
    */
    
  }

  
  
}
